;BattleShip Puzzler Thing
;Written by Dabz 2006

Include "grid.bb"
Graphics 640,480,16,2
SetBuffer BackBuffer()

Const GRID_WIDTH = 15
Const GRID_HEIGHT = 15
Local hitAmount,turns

Dim grid(GRID_WIDTH,GRID_HEIGHT)
Dim loadedGrid(GRID_WIDTH,GRID_HEIGHT)

;load grid (And amount of hitpoints)
Restore gridData
For loopy = 0 To GRID_HEIGHT-1
	For loopx = 0 To GRID_WIDTH-1
		Read someData
		loadedGrid(loopx,loopy) = someData
	Next
Next
Read someData
hitAmount = someData

;load images
tiles = LoadAnimImage("batTiles.png",16,16,0,9)
cursor = LoadImage("curs.bmp")

;Main loop
Repeat
Cls
mx = MouseX()
my = MouseY()

;Draw non-loaded grid grid
For loopy = 0 To GRID_HEIGHT-1
	For loopx = 0 To GRID_WIDTH-1
		DrawImage tiles, loopx Shl 4,loopy Shl 4,grid(loopx,loopy)
	Next
Next

;Show how many hitpoints are on each row and column
;ROWS
For loopy = 0 To GRID_HEIGHT-1
	count = 0
	For loopx = 0 To GRID_WIDTH-1
		If loadedGrid(loopx,loopy) > 2
			count = count + 1
		End If
	Next
	Text (loopx+1) Shl 4,(loopy Shl 4)+2,count
Next
;COLUMNS
For loopx = 0 To GRID_WIDTH-1
	count = 0
	For loopy = 0 To GRID_HEIGHT-1
		If loadedGrid(loopx,loopy) > 2
			count = count + 1
		End If
	Next
	Text (loopx Shl 4)+2,(loopy+1) Shl 4,count
Next


;Uncover square
If MouseHit(1) And grid(mx Shr 4,my Shr 4) = 0
	If loadedGrid(mx Shr 4,my Shr 4) > 2
		grid(mx Shr 4,my Shr 4) = 2
	Else
		grid(mx Shr 4,my Shr 4) = 1
	End If
	turns = turns + 1
End If

;check hitpoints (see if all the ships have been hit)
hitPoints = 0
For loopy = 0 To GRID_HEIGHT-1
	For loopx = 0 To GRID_WIDTH-1
		If grid(loopx,loopy) = 2 Then hitpoints = hitpoints + 1
		If hitPoints = hitAmount
			For loopy = 0 To GRID_HEIGHT-1
				For loopx = 0 To GRID_WIDTH-1
					DrawImage tiles, loopx Shl 4,loopy Shl 4,loadedgrid(loopx,loopy)
				Next
			Next
			Text 260,0,"It took you "+turns+" clicks!"
			Flip 
			WaitKey
			End 
		End If
	Next
Next

;Draw Cursor
DrawImage cursor,mx,my

;info'
Text 280,0,"Turns:"+turns

Flip
Until KeyDown(1)


End 